<?php

include('engine/core/Object.class.php');
include('engine/core/Router.class.php');
include('engine/core/Action.class.php');
include('engine/core/View.class.php');

class Engine extends Object {

    static public $Error;

    static public function Error ($text) {
        self::$Error .= $text .'</br>';
    }
    
    static public function GetError () {
        return self::$Error;
    }
    
    /**
     *   ,    
     */
    static public function LoadModules () {        
        
        $modules = self::GetConfig('modules');
        
        if ($modules[Router::$Action]) {
        
            if ($modules[Router::$Action] == '*') {
                
                $dir = opendir(ROOT_DIR .'/engine/modules/');
                while (false !== ($file = readdir($dir))) { 
                    if ($file != "." && $file != "..") { 
                        include(ROOT_DIR .'/engine/modules/' .$file);
                    } 
                }
                closedir($dir);

            }
            elseif(gettype($modules[Router::$Action]) == 'array') {
                
                foreach ($modules[Router::$Action] AS $module) {
                    include(ROOT_DIR .'/engine/modules/'. $module .'.php');
                };
            
            }
        }
        else {
        
            if ($modules['default'] == '*') {
                
                $dir = opendir(ROOT_DIR .'/engine/modules/');
                while (false !== ($file = readdir($dir))) { 
                    if ($file != "." && $file != "..") { 
                        include(ROOT_DIR .'/engine/modules/'. $file);
                    } 
                }
                closedir($dir);
            
            }
            elseif(gettype($modules['default']) == 'array') {
                
                foreach ($modules['default'] AS $module) {
                    include(ROOT_DIR .'/engine/modules/'. $module .'.php');
                }
            
            }

        }
                
    }
    
    /**
     *  
     */
    static public function LoadTemplate () {
        
        View::load(View::$template);
        View::assign('global', '{theme}', SITE_URL .'templates/'. THEME .'/');
        View::assign('global', '{site_url}', SITE_URL);
        echo View::build(View::$template);
  
    }
    
    /*
     *     classes,     
     */    
    static public function LoadClass($class_name) {
    
        if (!$class_name) $class_name = Router::$Action;
        
        if (file_exists(ROOT_DIR .'/engine/classes/'. $class_name .'.php')) {
            include ROOT_DIR.'/engine/classes/'.$class_name.'.php';
            //        
            $class_name = $class_name.'_class';  
            Action::$Model = new $class_name;
        } 
        
    }
   
    /**
     *     
     */
    function GetConfig ($file_name) {
    
        if (file_exists(ROOT_DIR.'/engine/config/'.$file_name.'.php')) {
            return include (ROOT_DIR.'/engine/config/'.$file_name.'.php');
        }
        return false;
        
    }
                    
}